

var _workGoAppCallbacks = {
    callbackMap: new Map(),
    key: 0,

    add: function(callback) {
        var key = this.key++;
        this.callbackMap.set(key, callback);
        return key;
    },

    perform: function(key, result, shouldRelase) {
        if (this.callbackMap.has(key)) {
            var callback = this.callbackMap.get(key);
            callback(result);
            
            if (shouldRelase) {
                this.callbackMap.delete(key);
            }
        }
    }, 

    release: function(key) {
        if (this.callbackMap.has(key)) {
            this.callbackMap.delete(key);
        }
    }
}

var _workGoAppObserver = window.webkit.messageHandlers.workgo;

var workgo = {

    token: undefined,

    sendLog: function(message) {
        var msg = {
            'function':'sendLog',
            'params': {
                'msg':message
            }
        }
        _workGoAppObserver.postMessage(msg)
    },

    getAuth: function (appId, secretKey, callback) {
        var key = _workGoAppCallbacks.add(callback)

        var msg = {
            'function': 'getAuth',
            'params': {
                'appId': appId,
                'secretKey': secretKey,
                'callback': key
            }
        }
        _workGoAppObserver.postMessage(msg)
    },
    
    getSystemInfo: function(callback){
        var key = _workGoAppCallbacks.add(callback)
        var msg = {
            'function':'getSystemInfo',
            'params': {
                'callback':key
            }
        }
        _workGoAppObserver.postMessage(msg)
    },

    navSetTitle: function(title) {
        var msg = {
            'function':'navSetTitle',
            'params': {
                'title':title
            }
        }
        _workGoAppObserver.postMessage(msg)
    },

    navGoBack: function() {
        var msg = {
            'function':'navGoBack',
            'params': { }
        }
        _workGoAppObserver.postMessage(msg)
    },

    navClose: function() {
        var msg = {
            'function':'navClose',
            'params': { }
        }
        _workGoAppObserver.postMessage(msg)
    }

}
